@echo off
rem * Ultimate MASM32 MakeIt.bat v1.10 by Mark Jones 2005 *
rem   appname is the .asm file without the file extension
rem   rsrcname is the .rc file without the extension
rem   console=0 for GUI apps, 1 for console apps
rem   debug=1 generates COFF debug information
rem   run=1 launches the .exe afterwards
rem   pauses only on error - no waiting
rem   .obj and .res files are deleted

rem ----------------------- Only edit values between here --------
set appname="szlen"
set rsrcname=""
set console=1
set debug=0
set run=1
rem --------------------------------- and here -------------------

set BIN=\masm32\bin
set LIB=\masm32\lib
set INCLUDE=\masm32\include
set err=0

if exist %appname%.obj del %appname%.obj
if exist %appname%.exe del %appname%.exe

if not exist %bin%\ml.exe goto patherror

if %rsrcname%=="" goto skip_rc
    %bin%\rc /v %rsrcname%.rc
    if errorlevel 1 set err=1
    %bin%\cvtres /machine:ix86 %rsrcname%.res
    if errorlevel 1 set err=1
    set rc=%rsrcname%.res
:skip_rc

if %console%==1 goto console
if %debug%==1 goto windebugver

:winreleasever
    %bin%\ml /c /coff /Cp %appname%.asm
    if errorlevel 1 set err=1
    echo.
    %bin%\link /SUBSYSTEM:WINDOWS /RELEASE /VERSION:4.0 %appname%.obj %rc%
    if errorlevel 1 set err=1
    goto finish

:windebugver
    %bin%\ml /c /coff /Cp /Fm /Zi /Zd %appname%.asm
    if errorlevel 1 set err=1
    echo.
    %bin%\link /SUBSYSTEM:WINDOWS /DEBUG /DEBUGTYPE:CV /VERSION:4.0 /INCREMENTAL:NO %appname%.obj %rc%
    if errorlevel 1 set err=1
    goto finish

:console
if %debug%==1 goto consoledebugver

:consolereleasever
    %bin%\ml /c /coff /Cp %appname%.asm
    if errorlevel 1 set err=1
    echo.
    %bin%\link /SUBSYSTEM:CONSOLE /RELEASE /VERSION:4.0 %appname%.obj %rc%
    if errorlevel 1 set err=1
    goto finish

:consoledebugver
    %bin%\ml /c /coff /Cp /Fm /Zi /Zd %appname%.asm
    if errorlevel 1 set err=1
    echo.
    %bin%\link /SUBSYSTEM:CONSOLE /DEBUG /VERSION:4.0 %appname%.obj %rc%
    if errorlevel 1 set err=1

:finish
    if %err%==1 pause
    if exist %appname%.obj del .\*.obj
    if not %rsrcname%=="" del %rsrcname%.res

if %run%==0 goto end

:runafter
    echo * Running application *
    echo.
    %appname%.exe
    goto end

:patherror
    echo.
    echo  ML.EXE was not found in the path - compilation terminated!

:end